/*------------------------------------------------------------------------------
* Alpha Shooter
* A 3D OpenGL First-Person Shooter game
* Copyright (C) 2005, 2006, 2007 Nicola Cocchiaro <ncocchiaro@users.sf.net>
* Alpha Shooter can be found at http://www.sf.net/projects/alphashooter.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 or, (at your option) any later
* version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*-------------------------------------------------------------------------------
*/


// dlists.h
// display lists header

#ifndef ALPSHOOT_DLISTS_H
#define ALPSHOOT_DLISTS_H

#ifdef ALPSHOOT_WIN32
#include <windows.h>
#endif

#ifndef ALPSHOOT_MACOSX
#include <GL/glut.h>
#else
#include <glut.h>
#endif

#include "defs.h"
#include "texture.h"

/* display lists to be used */
struct dlists_t {
	GLuint emit_off_list;
	GLuint crosshair_list;
	GLuint white_list;
	GLuint green_list;
	GLuint red_list;
	GLuint blue_list;
	GLuint explosion_list;
	GLuint shots_list;
	GLuint crate_list;
	GLuint compass_list;
	GLuint barrel_list;
	GLuint sub_fence_list;
	GLuint fence_list;
	GLuint post_list;
	GLuint double_post_list;
	GLuint sphere_list;
	GLuint console_list;
	GLuint container_list;
	GLuint door_list;
	GLuint fan_list;
	GLuint panel_list;
	GLuint tunnel_list;
	GLuint redlight_list;
	GLuint walls_list;
	GLuint window_list;
	GLuint ceiling_list;
	GLuint floor_list;
	GLuint monitor_base_list;
	GLuint monitor_list;
	GLuint lights_list;
	GLuint platform_list;
	GLuint ventilation_list;
	GLuint decor_list;
};
typedef struct dlists_t dlists_t;

void draw_xz_tile(GLfloat i, GLfloat k, GLfloat j);
void draw_xy_tile(GLfloat i, GLfloat k, GLfloat j);
void draw_monitor(GLuint texture);
void draw_platform(GLuint texture);
void set_crosshair_material();
void set_emit_off();
void set_white_list();
void set_green_list();
void set_red_list();
void set_blue_list();
void set_explosion_list();
void set_shots_material();
void draw_crosshair();
void set_crate();
void set_compass_list();
void set_barrel_list();
void set_subfence_list();
void set_fence_list();
void set_post_list();
void set_double_post_list();
void set_sphere_list();
void set_console_list();
void set_container_list();
void set_door_list();
void set_fan_list();
void set_panel_list();
void set_tunnel_list();
void set_redlight_list();
void set_walls_list();
void set_window_list();
void set_ceiling_list();
void set_floor_list();
void set_monitor_base_list();
void set_monitor_list();
void set_lights_list();
void set_platform_list();
void set_ventilation_list();
void set_decor_list();

extern dlists_t *dl;
extern GLUquadricObj *qobj;

#endif
