/*------------------------------------------------------------------------------
* Alpha Shooter
* A 3D OpenGL First-Person Shooter game
* Copyright (C) 2005, 2006, 2007 Nicola Cocchiaro <ncocchiaro@users.sf.net>
* Alpha Shooter can be found at http://www.sf.net/projects/alphashooter.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 or, (at your option) any later
* version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*-------------------------------------------------------------------------------
*/


// fps.h
// framerate calculator header file

#ifndef ALPSHOOT_FPS_H
#define ALPSHOOT_FPS_H

#ifdef ALPSHOOT_WIN32
#include <windows.h>
#endif

#include <sys/time.h>
#include "defs.h"
#include "display.h"

/* struct to calculate and store fps and movement rates */
struct fps_t {
	// framerate
	GLdouble fps;
	// movement rates
	GLdouble shift;
	GLdouble rot;
	// fps string to be displayed
	char fps_string[10];
	// values to calculate fps
	struct timeval *fps_start;
	struct timeval *fps_end;
	GLdouble interval;
	GLdouble elapsed;
};
typedef struct fps_t fps_t;

void frame_counter();
void calculate_fps();

extern fps_t *fps;

#endif
