/*------------------------------------------------------------------------------
* Alpha Shooter
* A 3D OpenGL First-Person Shooter game
* Copyright (C) 2005, 2006, 2007 Nicola Cocchiaro <ncocchiaro@users.sf.net>
* Alpha Shooter can be found at http://www.sf.net/projects/alphashooter.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 or, (at your option) any later
* version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*-------------------------------------------------------------------------------
*/

// texture.h
// header file for some opearations for texture mapping

#ifndef ALPSHOOT_TEXTURE_H
#define ALPSHOOT_TEXTURE_H

#ifdef ALPSHOOT_WIN32
#include <windows.h>
#endif

#ifndef ALPSHOOT_MACOSX
#include <GL/glut.h>
#else
#include <glut.h>
#endif

#include "tgaload.h"

#define AS_MAXTEXTURES	64
#define AS_LASTTEXTURE	31

#define CRATE_WARN	0
#define CRATE_RCKTS	1
#define CRATE_EXPLO	2
#define CRATE_VENTS	3
#define FLOOR_METAL	4
#define BEAM_METAL	5
#define ROCK_WALL	6
#define FLOOR_GRATE	7
#define COMPASS		8
#define BARREL_TOP	9
#define BARREL_SIDE	10
#define FENCE		11
#define PANEL		12
#define METAL		13
#define CONSOLE		14
#define CONSOLE2	15
#define CONTAINER	16
#define DOOR_METAL	17
#define BUMP_PLAT	18
#define FAN		19
#define DARK_METAL	20
#define VENT		21
#define METAL2		22
#define BRONZE		23
#define WHITE		24
#define REDLIGHT	25
#define MONITOR1	26
#define MONITOR2	27
#define MONITOR3	28
#define MONITOR4	29
#define WARN		30

/* texture names and data list */
struct texture_t {
	// list of registered textures
	GLuint tex_names[AS_MAXTEXTURES];
	// temporary data field for loading textures
	tImageTGA *tex_data;
};
typedef struct texture_t texture_list;

void init_texture(const char *filename, GLint tex_num, GLint format);

extern texture_list *tex;

#endif
